All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
PAbstractDictionary Class Reference

An abstract dictionary container. More...

`#include <dict.h>`

Inheritance diagram for PAbstractDictionary:

## Public Member Functions

Construction
PINLINE | PAbstractDictionary ()
| Create a new, empty, dictionary. More...
Overrides from class PObject
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
Overrides from class PCollection
virtual PINDEX | Insert (const PObject &key, PObject *obj)
| Insert a new object into the dictionary. More...
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)
| Insert a new object at the specified index. More...
virtual PObject * | RemoveAt (PINDEX index)
| Remove an object at the specified index. More...
virtual PBoolean | SetAt (PINDEX index, PObject *val)
| Set the object at the specified index to the new value. More...
virtual PObject * | GetAt (PINDEX index) const
| Get the object at the specified index position. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object. More...
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object. More...
New functions for class
virtual PBoolean | SetDataAt (PINDEX index, PObject *obj)
| Set the data at the specified ordinal index position in the dictionary. More...
virtual PBoolean | AbstractSetAt (const PObject &key, PObject *obj)
| Add a new object to the collection. More...
virtual PObject & | GetRefAt (const PObject &key) const
| Get the object at the specified key position. More...
virtual PObject * | AbstractGetAt (const PObject &key) const
| Get the object at the specified key position. More...
virtual void | AbstractGetKeys (PArrayObjects &keys) const
| Get an array containing all the keys for the dictionary. More...
Public Member Functions inherited from PHashTable
| PHashTable ()
| Create a new, empty, hash table. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two hash tables. More...
virtual PBoolean | SetSize (PINDEX newSize)
| This function is meaningless for hash table. More...
PINLINE PBoolean | AbstractContains (const PObject &key) const
| Determine if the value of the object is contained in the hash table. More...
virtual const PObject & | AbstractGetKeyAt (PINDEX index) const
| Get the key in the hash table at the ordinal index position. More...
virtual PObject & | AbstractGetDataAt (PINDEX index) const
| Get the data in the hash table at the ordinal index position. More...
Public Member Functions inherited from PCollection
| PCollection (PINDEX initialSize=0)
| Create a new collection. More...
virtual void | RemoveAll ()
| Remove all of the elements in the collection. More...
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection. More...
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
virtual PINDEX | GetSize () const
| Get the current size of the container. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions

PINLINE | PAbstractDictionary (int dummy, const PAbstractDictionary *c)
Protected Member Functions inherited from PCollection
PINLINE | PCollection (int dummy, const PCollection *coll)
| Constructor used in support of the Clone() function. More...
Protected Member Functions inherited from PContainer
| PContainer (int dummy, const PContainer *cont)
| Constructor used in support of the Clone() function. More...
| PContainer (PContainerReference &reference)
| Construct using static PContainerReference. More...
virtual void | DestroyContents ()=0
| Destroy the container contents. More...
virtual void | AssignContents (const PContainer &c)
| Copy the container contents. More...
void | CopyContents (const PContainer &c)
| Copy the container contents. More...
void | CloneContents (const PContainer *src)
| Create a duplicate of the container contents. More...
void | Destruct ()
| Internal function called from container destructors. More...
virtual void | DestroyReference ()
| Destroy the PContainerReference instance. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Additional Inherited Members

Public Types inherited from PHashTable
typedef PHashTableElement | Element
typedef PHashTableInfo | Table
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
Public Attributes inherited from PHashTable
PHashTableInfo * | hashTable
Protected Attributes inherited from PContainer
PContainerReference * | reference

## Detailed Description

An abstract dictionary container.

## Constructor & Destructor Documentation

PINLINE PAbstractDictionary::PAbstractDictionary | ( |  | ) |

Create a new, empty, dictionary.

Note that by default, objects placed into the dictionary will be deleted when removed or when all references to the dictionary are destroyed.

PINLINE PAbstractDictionary::PAbstractDictionary | ( | int | dummy,
|  | const PAbstractDictionary * | c
| ) |  |

protected

## Member Function Documentation

virtual PObject* PAbstractDictionary::AbstractGetAt | ( | const PObject & | key | ) | const

virtual

Get the object at the specified key position.

If the key was not in the collection then NULL is returned.

Returns
  pointer to object at the specified key.

Parameters

  key | Key for position in dictionary to get object.

Referenced by PDictionary< PString, PNotifierList >::GetAt(), POrdinalDictionary< K >::GetAt(), and PStringDictionary< K >::GetAt().

virtual void PAbstractDictionary::AbstractGetKeys | ( | PArrayObjects & | keys | ) | const

virtual

Get an array containing all the keys for the dictionary.

Referenced by PDictionary< PString, PNotifierList >::GetKeys().

virtual PBoolean PAbstractDictionary::AbstractSetAt | ( | const PObject & | key,
|  | PObject * | obj
| ) |  |

virtual

Add a new object to the collection.

If the objects value is already in the dictionary then the object is overrides the previous value. If the AllowDeleteObjects option is set then the old object is also deleted.

The object is placed in the an ordinal position dependent on the keys hash function. Subsequent searches use the hash function to speed access to the data item.

Returns
  true if the object was successfully added.

Parameters

  key | Key for position in dictionary to add object.
  obj | New object to put into the dictionary.

Referenced by PDictionary< PString, PNotifierList >::RemoveAt(), POrdinalDictionary< K >::RemoveAt(), PStringDictionary< K >::RemoveAt(), PDictionary< PString, PNotifierList >::SetAt(), POrdinalDictionary< K >::SetAt(), and PStringDictionary< K >::SetAt().

virtual PObject* PAbstractDictionary::GetAt | ( | PINDEX | index | ) | const

virtual

Get the object at the specified index position.

If the index was not in the collection then NULL is returned.

Returns
  pointer to object at the specified index.

Parameters

  index | Index position in the collection of the object.

Implements PCollection.

virtual PINDEX PAbstractDictionary::GetObjectsIndex | ( | const PObject * | obj | ) | const

virtual

Search the collection for the specific instance of the object.

The object pointers are compared, not the values. The hash table is used to locate the entry.

Note that that will require value comparisons to be made to find the equivalent entry and then a final check is made with the pointers to see if they are the same instance.

Returns
  ordinal index position of the object, or P_MAX_INDEX.

Parameters

  obj | Object to find.

Implements PCollection.

virtual PObject& PAbstractDictionary::GetRefAt | ( | const PObject & | key | ) | const

virtual

Get the object at the specified key position.

If the key was not in the collection then this function asserts.

This function is primarily for use by the operator[] function in the descendent template classes.

Returns
  reference to object at the specified key.

Parameters

  key | Key for position in dictionary to get object.

Referenced by PDictionary< PString, PNotifierList >::operator[](), POrdinalDictionary< K >::operator[](), and PStringDictionary< K >::operator[]().

virtual PINDEX PAbstractDictionary::GetValuesIndex | ( | const PObject & | obj | ) | const

virtual

Search the collection for the specified value of the object.

The object values are compared, not the pointers. So the objects in the collection must correctly implement the `PObject::Compare()` function. The hash table is used to locate the entry.

Returns
  ordinal index position of the object, or P_MAX_INDEX.

Parameters

  obj | Object to find value of.

Implements PCollection.

virtual PINDEX PAbstractDictionary::Insert | ( | const PObject & | key,
|  | PObject * | obj
| ) |  |

virtual

Insert a new object into the dictionary.

The semantics of this function is different from that of the `PCollection` class. This function is exactly equivalent to the `SetAt()` function that sets a data value at the key value location.

Returns
  Always zero.

Parameters

  key | Object value to use as the key.
  obj | New object to place into the collection.

Implements PCollection.

virtual PINDEX PAbstractDictionary::InsertAt | ( | PINDEX | index,
|  | PObject * | obj
| ) |  |

virtual

Insert a new object at the specified index.

This function only applies to derived classes whose key is PINDEX based.

Returns
  `index` parameter.

Parameters

  index | Index position in collection to place the object.
  obj | New object to place into the collection.

Implements PCollection.

virtual void PAbstractDictionary::PrintOn | ( | ostream & | strm | ) | const

virtual

Output the contents of the object to the stream.

The exact output is dependent on the exact semantics of the descendent class. This is primarily used by the standard `operator<<` function.

The default behaviour is to print the class name.

Parameters

  strm | Stream to print the object into.

Reimplemented from PCollection.

Reimplemented in PMIMEInfo.

virtual PObject* PAbstractDictionary::RemoveAt | ( | PINDEX | index | ) |

virtual

Remove an object at the specified index.

This function only applies to derived classes whose key is PINDEX based. The returned pointer is then removed using the `SetAt()` function to set that key value to NULL. If the `AllowDeleteObjects` option is set then the object is also deleted.

Returns
  pointer to the object being removed, or NULL if it was deleted.

Parameters

  index | Index position in collection to place the object.

Implements PCollection.

virtual PBoolean PAbstractDictionary::SetAt | ( | PINDEX | index,
|  | PObject * | val
| ) |  |

virtual

Set the object at the specified index to the new value.

This function only applies to derived classes whose key is PINDEX based. This will overwrite the existing entry. If the AllowDeleteObjects() option is set then the old object is also deleted.

Returns
  true if the object was successfully added.

Parameters

  index | Index position in collection to set.
  val | New value to place into the collection.

Implements PCollection.

virtual PBoolean PAbstractDictionary::SetDataAt | ( | PINDEX | index,
|  | PObject * | obj
| ) |  |

virtual

Set the data at the specified ordinal index position in the dictionary.

The ordinal position in the dictionary is determined by the hash values of the keys and the order of insertion.

Returns
  true if the new object could be placed into the dictionary.

Parameters

  index | Ordinal index in the dictionary.
  obj | New object to put into the dictionary.

Referenced by POrdinalDictionary< K >::SetDataAt(), and PStringDictionary< K >::SetDataAt().

The documentation for this class was generated from the following file:

- dict.h